---
title: '-moz-device-pixel-ratio'
slug: Web/CSS/@media/-moz-device-pixel-ratio
tags:
  - '@media'
  - CSS
  - Deprecated
  - Non-standard
  - media feature
---
<div>{{cssref}} {{Non-standard_header}} {{Deprecated_header}}</div>

<p>The <strong><code>-moz-device-pixel-ratio</code></strong> Gecko-only <a href="/en-US/docs/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#Media_features">media feature</a> can be used to apply styles based on the number of device pixels per CSS pixel.</p>

<div class="warning">
<p><strong>Do not use this feature. </strong>Use the <code><a href="/en-US/docs/Web/CSS/@media/resolution">resolution</a></code> feature with the <code>dppx</code> unit instead.</p>
</div>

<div class="note"><strong>Note</strong>: This media feature is also implemented by Webkit and by <a href="https://msdn.microsoft.com/en-us/library/ie/dn760733(v=vs.85).aspx">IE 11 for Windows Phone 8.1</a> as <code>-webkit-device-pixel-ratio</code>. The min and max prefixes as implemented by Gecko are named <code>min--moz-device-pixel-ratio</code> and <code>max--moz-device-pixel-ratio</code>; but the same prefixes as implemented by Webkit are named <code>-webkit-min-device-pixel-ratio</code> and <code>-webkit-max-device-pixel-ratio</code>.</div>

<h2 id="Syntax">Syntax</h2>

<dl>
 <dt>{{cssxref("&lt;number&gt;")}}</dt>
 <dd>The number of device pixels per CSS pixel.</dd>
</dl>

<p><br>
 <strong>Media:</strong> {{cssxref("Media/Visual")}}<br>
 <strong>Accepts min/max prefixes:</strong> yes</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_compatibility_example">Basic compatibility example</h3>

<p><code>-moz-device-pixel-ratio</code> may be used for compatibility with Firefox older than 16, and alongside <code>-webkit-device-pixel-ratio</code> for compatibility with WebKit-based browsers that do not support <code>dppx</code>.</p>

<p>Example:</p>

<pre class="brush: css notranslate">@media (-webkit-min-device-pixel-ratio: 2), /* Webkit-based browsers */
       (min--moz-device-pixel-ratio: 2),    /* Older Firefox browsers (prior to Firefox 16) */
       (min-resolution: 2dppx),             /* The standard way */
       (min-resolution: 192dpi)             /* dppx fallback */ </pre>

<div class="notecard note">
<p><strong>Note</strong>: See this <a href="http://www.w3.org/blog/CSS/2012/06/14/unprefix-webkit-device-pixel-ratio/">CSSWG article</a> for compatibility good practices regarding <code>resolution</code> and <code>dppx</code>.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.media.-moz-device-pixel-ratio")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">Using Media Queries</a></li>
 <li><a href="/en-US/docs/Web/CSS/@media">@media</a></li>
</ul>
